package com.loafle.overflow.proxy.db;

import java.lang.reflect.Method;
import java.util.ArrayList;
import java.util.List;

/**
 * Created by root on 17. 6. 23.
 */
public class MethodSeeker {

    private static List<Class<?>> typeList = null;

    static {
        MethodSeeker.typeList = new ArrayList<>();

        //normal
        MethodSeeker.typeList.add(Object.class);
        //findOne
        MethodSeeker.typeList.add(java.io.Serializable.class);
    }


    public static Method getMethod(Class cls, String methodName, List<Class> paramTypes) {

        Method method = null;

        if(paramTypes != null) {
            method = MethodSeeker.getMethodType(cls, methodName, paramTypes.toArray(new Class[paramTypes.size()]));
        }

        if(method != null) {
            return method;
        }


        for(Class<?> type : MethodSeeker.typeList) {
            method = MethodSeeker.getMethodType(cls,methodName, type);
            if(method != null) {
                return method;
            }
        }

        return method;

    }

    private static Method getMethodType(Class jpa, String methodName, Class<?> ...type) {
        if (jpa == null) {
            return null;
        }
        Method m = null;
        try {
            m = jpa.getMethod(methodName, type);
        } catch (NoSuchMethodException e) {
            return MethodSeeker.getMethodType(jpa.getSuperclass(), methodName, type);
        }

        return m;
    }
}
