package com.loafle.overflow.meta.dao;

import com.loafle.overflow.AppConfig;
import com.loafle.overflow.JdbcConfiguration;
import com.loafle.overflow.meta.model.MetaCrawler;
import com.loafle.overflow.meta.model.MetaCrawlerInputItem;
import com.loafle.overflow.meta.model.MetaInputType;
import org.junit.Ignore;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.test.context.ContextConfiguration;
import org.springframework.test.context.junit4.SpringJUnit4ClassRunner;

import static org.junit.Assert.*;

/**
 * Created by root on 17. 6. 25.
 */
@RunWith(SpringJUnit4ClassRunner.class)
@ContextConfiguration(classes = {AppConfig.class, JdbcConfiguration.class})
public class MetaCrawlerInputItemDAOTest {

    @Autowired
    private MetaCrawlerInputItemDAO metaCrawlerInputItemDAO;

    @Ignore
    @Test
    public void craete() {

        MetaInputType typeText = new MetaInputType();
        typeText.setId((short)1);

        MetaInputType typePW = new MetaInputType();
        typePW.setId((short)2);


        int ID = 0;
        //WMI
        {
            MetaCrawler crawlerWMI = new MetaCrawler();
            crawlerWMI.setId((short)1);

            MetaCrawlerInputItem itemID = new MetaCrawlerInputItem();
            itemID.setId(++ID);
            itemID.setMetaInputType(typeText);
            itemID.setMetaCrawler(crawlerWMI);
            itemID.setRequired(true);
            itemID.setDescription("Windows Account ID");
            itemID.setPattern("");
            itemID.setName("ID");
            itemID.setDefaultValue("Loafle");

            MetaCrawlerInputItem itemPW = new MetaCrawlerInputItem();
            itemPW.setId(++ID);
            itemPW.setMetaInputType(typePW);
            itemPW.setMetaCrawler(crawlerWMI);
            itemPW.setRequired(true);
            itemPW.setDescription("Windows Account PW");
            itemPW.setPattern("");
            itemPW.setName("PassWord");
            itemPW.setDefaultValue("");

            this.metaCrawlerInputItemDAO.save(itemID);
            this.metaCrawlerInputItemDAO.save(itemPW);
        }


        //SNMP V2
        {
            MetaCrawler crawlerSNMPV2 = new MetaCrawler();
            crawlerSNMPV2.setId((short)2);

            MetaCrawlerInputItem itemCommunity = new MetaCrawlerInputItem();
            itemCommunity.setId(++ID);
            itemCommunity.setMetaInputType(typeText);
            itemCommunity.setMetaCrawler(crawlerSNMPV2);
            itemCommunity.setRequired(true);
            itemCommunity.setDescription("SNMP V2 Community");
            itemCommunity.setPattern("");
            itemCommunity.setName("Community");
            itemCommunity.setDefaultValue("public");

            this.metaCrawlerInputItemDAO.save(itemCommunity);
        }


        //MySQL
        {
            MetaCrawler crawlerMySQL = new MetaCrawler();
            crawlerMySQL.setId((short)4);

            MetaCrawlerInputItem itemDB = new MetaCrawlerInputItem();
            itemDB.setId(++ID);
            itemDB.setMetaInputType(typeText);
            itemDB.setMetaCrawler(crawlerMySQL);
            itemDB.setRequired(true);
            itemDB.setDescription("MYSQL DB Name");
            itemDB.setPattern("");
            itemDB.setName("DB Name");
            itemDB.setDefaultValue("mysqldb");

            MetaCrawlerInputItem itemID = new MetaCrawlerInputItem();
            itemID.setId(++ID);
            itemID.setMetaInputType(typeText);
            itemID.setMetaCrawler(crawlerMySQL);
            itemID.setRequired(true);
            itemID.setDescription("MYSQL Account ID");
            itemID.setPattern("");
            itemID.setName("ID");
            itemID.setDefaultValue("Loafle");

            MetaCrawlerInputItem itemPW = new MetaCrawlerInputItem();
            itemPW.setId(++ID);
            itemPW.setMetaInputType(typePW);
            itemPW.setMetaCrawler(crawlerMySQL);
            itemPW.setRequired(true);
            itemPW.setDescription("MYSQL Account PW");
            itemPW.setPattern("");
            itemPW.setName("PassWord");
            itemPW.setDefaultValue("");

            this.metaCrawlerInputItemDAO.save(itemDB);
            this.metaCrawlerInputItemDAO.save(itemID);
            this.metaCrawlerInputItemDAO.save(itemPW);
        }

    }

}