package com.loafle.overflow.meta.dao;

import com.loafle.overflow.AppConfig;
import com.loafle.overflow.JdbcConfiguration;
import com.loafle.overflow.meta.model.MetaProbeArchitecture;
import com.loafle.overflow.meta.model.MetaProbeOs;
import com.loafle.overflow.meta.model.MetaProbePackage;
import com.loafle.overflow.meta.model.MetaProbeVersion;
import org.junit.Ignore;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.test.context.ContextConfiguration;
import org.springframework.test.context.junit4.SpringJUnit4ClassRunner;

import java.util.ArrayList;
import java.util.List;

import static org.junit.Assert.*;

/**
 * Created by root on 17. 6. 25.
 */
@RunWith(SpringJUnit4ClassRunner.class)
@ContextConfiguration(classes = {AppConfig.class, JdbcConfiguration.class})
public class MetaProbePackageDAOTest {

    @Autowired
    private MetaProbePackageDAO metaProbePackageDAO;

    @Ignore
    @Test
    public void create()
    {

        MetaProbeArchitecture ax8632 = new MetaProbeArchitecture();
        ax8632.setId((short)1);

        MetaProbeArchitecture ax8664 = new MetaProbeArchitecture();
        ax8664.setId((short)2);

        List<MetaProbeArchitecture> archilist = new ArrayList<>();
        archilist.add(ax8632);
        archilist.add(ax8664);

        MetaProbeOs metaWindows = new MetaProbeOs();
        metaWindows.setId((short)1);

        MetaProbeOs metaDebian = new MetaProbeOs();
        metaDebian.setId((short)2);

        MetaProbeOs metaUbuntu = new MetaProbeOs();
        metaUbuntu.setId((short)3);

        MetaProbeOs metaFedora = new MetaProbeOs();
        metaFedora.setId((short)4);

        List<MetaProbeOs> probeOs = new ArrayList<>();
        probeOs.add(metaWindows);
        probeOs.add(metaDebian);
        probeOs.add(metaUbuntu);
        probeOs.add(metaFedora);


        MetaProbeVersion version100 = new MetaProbeVersion();
        version100.setId((short)1);

        MetaProbeVersion version110 = new MetaProbeVersion();
        version110.setId((short)2);

        List<MetaProbeVersion> versionlist = new ArrayList<>();

        versionlist.add(version100);
        versionlist.add(version110);




        for(MetaProbeVersion version : versionlist) {

            for(MetaProbeArchitecture architecture : archilist) {

                for(MetaProbeOs os : probeOs) {

                    MetaProbePackage aPackage = new MetaProbePackage();
                    aPackage.setOs(os);
                    aPackage.setArchitecture(architecture);
                    aPackage.setVersion(version);

                    this.metaProbePackageDAO.save(aPackage);

                }

            }

        }
    }

}