package com.loafle.overflow.module.infra.dao;

import com.loafle.overflow.AppConfig;
import com.loafle.overflow.JdbcConfiguration;
import com.loafle.overflow.meta.model.MetaInfraType;
import com.loafle.overflow.module.infra.model.Infra;
import com.loafle.overflow.module.infra.model.InfraMachine;
import com.loafle.overflow.module.probe.model.Probe;
import org.junit.After;
import org.junit.Before;
import org.junit.Ignore;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.test.context.ContextConfiguration;
import org.springframework.test.context.junit4.SpringJUnit4ClassRunner;

import java.util.Date;

@Ignore
@RunWith(SpringJUnit4ClassRunner.class)
@ContextConfiguration(classes = {AppConfig.class, JdbcConfiguration.class})
public class InfraDAOTest {

    @Autowired
    private InfraDAO infraDAO;

    @Autowired
    private InfraMachineDAO infraMachineDAO;

    private long machineId;

    @Before
    public void setUp() throws Exception {
        InfraMachine machine = new InfraMachine();
        machine.setCreateDate(new Date());
        Probe probe = new Probe();
        probe.setId(1);
        machine.setProbe(probe);

        this.machineId = this.infraMachineDAO.save(machine).getId();
    }

    @After
    public void tearDown() throws Exception {
    }


    @Test
    public void create() {
        Infra infra = new Infra();
        infra.setChildId(this.machineId);
        MetaInfraType type = new MetaInfraType();
        type.setId(1);
        infra.setType(type);
        infra.setCreateDate(new Date());

        infraDAO.save(infra);
    }


}