package com.loafle.overflow.module.noauthprobe.dao;

import com.loafle.overflow.AppConfig;
import com.loafle.overflow.JdbcConfiguration;
import com.loafle.overflow.meta.model.MetaNoAuthProbeStatus;
import com.loafle.overflow.module.domain.model.Domain;
import com.loafle.overflow.module.noauthprobe.model.NoAuthProbe;
import com.loafle.overflow.module.noauthprobe.type.AuthType;
import org.junit.Assert;
import org.junit.Ignore;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.test.context.ContextConfiguration;
import org.springframework.test.context.junit4.SpringJUnit4ClassRunner;

import java.util.List;

/**
 * Created by root on 17. 6. 22.
 */
@RunWith(SpringJUnit4ClassRunner.class)
@ContextConfiguration(classes = {AppConfig.class, JdbcConfiguration.class})
public class NoAuthProbeDAOTest {


    @Autowired
    private NoAuthProbeDAO noAuthProbeDAO;


    @Test
    public void testFindTempKey() {

        NoAuthProbe probe = this.noAuthProbeDAO.findByTempProbeKey("1cf2555c57d511e79714080027658d13");


        Assert.assertNotEquals(probe, null);

        System.out.println(probe.getTempProbeKey());

    }

    @Ignore
    @Test
    public void saveNoauth() {

        NoAuthProbe noAuthProbe = new NoAuthProbe();


        noAuthProbe.setHostName("snoop");
        noAuthProbe.setIpAddress(3232235980L);
        noAuthProbe.setMacAddress(8796753988883L);
        noAuthProbe.setApiKey("52abd6fd57e511e7ac52080027658d13");

        MetaNoAuthProbeStatus metaNoAuthProbeStatus = new MetaNoAuthProbeStatus();
        metaNoAuthProbeStatus.setId((short)3);

        noAuthProbe.setStatus(metaNoAuthProbeStatus);
        noAuthProbe.setTempProbeKey("1cf2555c57d511e79714080027658d13");

        Domain d = new Domain();
        d.setId(1);
        noAuthProbe.setDomain(d);

        this.noAuthProbeDAO.save(noAuthProbe);

        Assert.assertNotEquals(noAuthProbe.getId(), 0);

    }

    @Test
    public void update() {

        NoAuthProbe probe = this.noAuthProbeDAO.findByTempProbeKey("1cf2555c57d511e79714080027658d13");

//        probe.setStatus(AuthType.A);

        this.noAuthProbeDAO.save(probe);

    }

    @Test
    public void list() {

    Domain domain = new Domain();
    domain.setId(1);

        List<NoAuthProbe> probes = this.noAuthProbeDAO.findAllByDomain(domain);


        Assert.assertNotEquals(probes.size(), 0);

    }

    @Test
    public void findOne() {

        NoAuthProbe noAuthProbe = this.noAuthProbeDAO.findOne(1L);

        Assert.assertNotEquals(noAuthProbe, null);

    }

}